Index: branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 530)
+++ branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 531)
@@ -2054,550 +2471,692 @@
   xmlNodePtr n;
 
-  zooXmlCleanupNs();
-  doc = xmlNewDoc(BAD_CAST "1.0");
-  maps* tmpMap=getMaps(m,"main");
-  char *encoding=getEncoding(tmpMap);
+  zooXmlCleanupNs ();
+  doc = xmlNewDoc (BAD_CAST "1.0");
+  maps *tmpMap = getMaps (m, "main");
+  char *encoding = getEncoding (tmpMap);
   const char *exceptionCode;
-  
-  map* tmp=getMap(s,"code");
-  if(tmp!=NULL){
-    if(strcmp(tmp->value,"OperationNotSupported")==0)
-      exceptionCode="501 Not Implemented";
-    else
-      if(strcmp(tmp->value,"MissingParameterValue")==0 ||
-	 strcmp(tmp->value,"InvalidUpdateSequence")==0 ||
-	 strcmp(tmp->value,"OptionNotSupported")==0 ||
-	 strcmp(tmp->value,"VersionNegotiationFailed")==0 ||
-	 strcmp(tmp->value,"InvalidParameterValue")==0)
-	exceptionCode="400 Bad request";
+
+  map *tmp = getMap (s, "code");
+  if (tmp != NULL)
+    {
+      if (strcmp (tmp->value, "OperationNotSupported") == 0)
+        exceptionCode = "501 Not Implemented";
       else
-	if(strcmp(tmp->value,"NoApplicableCode")==0)
-	  exceptionCode="501 Internal Server Error";
-	else
-	  exceptionCode="501 Internal Server Error";
-  }
+        if (strcmp (tmp->value, "MissingParameterValue") == 0 ||
+            strcmp (tmp->value, "InvalidUpdateSequence") == 0 ||
+            strcmp (tmp->value, "OptionNotSupported") == 0 ||
+            strcmp (tmp->value, "VersionNegotiationFailed") == 0 ||
+            strcmp (tmp->value, "InvalidParameterValue") == 0)
+        exceptionCode = "400 Bad request";
+      else if (strcmp (tmp->value, "NoApplicableCode") == 0)
+        exceptionCode = "501 Internal Server Error";
+      else
+        exceptionCode = "501 Internal Server Error";
+    }
   else
-    exceptionCode="501 Internal Server Error";
-
-  if(m!=NULL){
-    map *tmpSid=getMapFromMaps(m,"lenv","sid");
-    if(tmpSid!=NULL){
-      if( getpid()==atoi(tmpSid->value) ){
-	printHeaders(m);
-	printf("Content-Type: text/xml; charset=%s\r\nStatus: %s\r\n\r\n",encoding,exceptionCode);
-      }
-    }
-    else{
-      printHeaders(m);
-      printf("Content-Type: text/xml; charset=%s\r\nStatus: %s\r\n\r\n",encoding,exceptionCode);
-    }
-  }else{
-    printf("Content-Type: text/xml; charset=%s\r\nStatus: %s\r\n\r\n",encoding,exceptionCode);
-  }
-  n=createExceptionReportNode(m,s,1);
-  xmlDocSetRootElement(doc, n);
-  xmlDocDumpFormatMemoryEnc(doc, &xmlbuff, &buffersize, encoding, 1);
-  printf("%s",xmlbuff);
-  fflush(stdout);
-  xmlFreeDoc(doc);
-  xmlFree(xmlbuff);
-  xmlCleanupParser();
-  zooXmlCleanupNs();
-  if(m!=NULL)
-    setMapInMaps(m,"lenv","hasPrinted","true");
-}
-
-xmlNodePtr createExceptionReportNode(maps* m,map* s,int use_ns){
-  
-  xmlNsPtr ns,ns_xsi;
-  xmlNodePtr n,nc,nc1;
-
-  int nsid=zooXmlAddNs(NULL,"http://www.opengis.net/ows","ows");
-  ns=usedNs[nsid];
-  if(use_ns==1){
-    ns=NULL;
-  }
-  n = xmlNewNode(ns, BAD_CAST "ExceptionReport");
-  if(use_ns==1){
-    xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",NULL);
-    int xsiId=zooXmlAddNs(n,"http://www.w3.org/2001/XMLSchema-instance","xsi");
-    ns_xsi=usedNs[xsiId];
-    xmlNewNsProp(n,ns_xsi,BAD_CAST "schemaLocation",BAD_CAST "http://www.opengis.net/ows/1.1 http://schemas.opengis.net/ows/1.1.0/owsExceptionReport.xsd");
-  }
-
-
-  addLangAttr(n,m);
-  xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.1.0");
-  
-  nc = xmlNewNode(ns, BAD_CAST "Exception");
-
-  map* tmp=getMap(s,"code");
-  if(tmp!=NULL)
-    xmlNewProp(nc,BAD_CAST "exceptionCode",BAD_CAST tmp->value);
+    exceptionCode = "501 Internal Server Error";
+
+  if (m != NULL)
+    {
+      map *tmpSid = getMapFromMaps (m, "lenv", "sid");
+      if (tmpSid != NULL)
+        {
+          if (getpid () == atoi (tmpSid->value))
+            {
+              printHeaders (m);
+              printf
+                ("Content-Type: text/xml; charset=%s\r\nStatus: %s\r\n\r\n",
+                 encoding, exceptionCode);
+            }
+        }
+      else
+        {
+          printHeaders (m);
+          printf ("Content-Type: text/xml; charset=%s\r\nStatus: %s\r\n\r\n",
+                  encoding, exceptionCode);
+        }
+    }
   else
-    xmlNewProp(nc,BAD_CAST "exceptionCode",BAD_CAST "NoApplicableCode");
-
-  tmp=getMap(s,"locator");
-  if(tmp!=NULL && strcasecmp(tmp->value,"NULL")!=0)
-    xmlNewProp(nc,BAD_CAST "locator",BAD_CAST tmp->value);
-
-
-  tmp=getMap(s,"text");
-  nc1 = xmlNewNode(ns, BAD_CAST "ExceptionText");
-  if(tmp!=NULL){
-    xmlNodeSetContent(nc1, BAD_CAST tmp->value);
-  }
-  else{
-    xmlNodeSetContent(nc1, BAD_CAST _("No debug message available"));
-  }
-  xmlAddChild(nc,nc1);
-  xmlAddChild(n,nc);
+    {
+      printf ("Content-Type: text/xml; charset=%s\r\nStatus: %s\r\n\r\n",
+              encoding, exceptionCode);
+    }
+  n = createExceptionReportNode (m, s, 1);
+  xmlDocSetRootElement (doc, n);
+  xmlDocDumpFormatMemoryEnc (doc, &xmlbuff, &buffersize, encoding, 1);
+  printf ("%s", xmlbuff);
+  fflush (stdout);
+  xmlFreeDoc (doc);
+  xmlFree (xmlbuff);
+  xmlCleanupParser ();
+  zooXmlCleanupNs ();
+  if (m != NULL)
+    setMapInMaps (m, "lenv", "hasPrinted", "true");
+}
+
+xmlNodePtr
+createExceptionReportNode (maps * m, map * s, int use_ns)
+{
+
+  xmlNsPtr ns, ns_xsi;
+  xmlNodePtr n, nc, nc1;
+
+  int nsid = zooXmlAddNs (NULL, "http://www.opengis.net/ows", "ows");
+  ns = usedNs[nsid];
+  if (use_ns == 1)
+    {
+      ns = NULL;
+    }
+  n = xmlNewNode (ns, BAD_CAST "ExceptionReport");
+  if (use_ns == 1)
+    {
+      xmlNewNs (n, BAD_CAST "http://www.opengis.net/ows/1.1", NULL);
+      int xsiId =
+        zooXmlAddNs (n, "http://www.w3.org/2001/XMLSchema-instance", "xsi");
+      ns_xsi = usedNs[xsiId];
+      xmlNewNsProp (n, ns_xsi, BAD_CAST "schemaLocation",
+                    BAD_CAST
+                    "http://www.opengis.net/ows/1.1 http://schemas.opengis.net/ows/1.1.0/owsExceptionReport.xsd");
+    }
+
+
+  addLangAttr (n, m);
+  xmlNewProp (n, BAD_CAST "version", BAD_CAST "1.1.0");
+
+  nc = xmlNewNode (ns, BAD_CAST "Exception");
+
+  map *tmp = getMap (s, "code");
+  if (tmp != NULL)
+    xmlNewProp (nc, BAD_CAST "exceptionCode", BAD_CAST tmp->value);
+  else
+    xmlNewProp (nc, BAD_CAST "exceptionCode", BAD_CAST "NoApplicableCode");
+
+  tmp = getMap (s, "locator");
+  if (tmp != NULL && strcasecmp (tmp->value, "NULL") != 0)
+    xmlNewProp (nc, BAD_CAST "locator", BAD_CAST tmp->value);
+
+
+  tmp = getMap (s, "text");
+  nc1 = xmlNewNode (ns, BAD_CAST "ExceptionText");
+  if (tmp != NULL)
+    {
+      xmlNodeSetContent (nc1, BAD_CAST tmp->value);
+    }
+  else
+    {
+      xmlNodeSetContent (nc1, BAD_CAST _("No debug message available"));
+    }
+  xmlAddChild (nc, nc1);
+  xmlAddChild (n, nc);
   return n;
 }
 
 
-void outputResponse(service* s,maps* request_inputs,maps* request_outputs,
-		    map* request_inputs1,int cpid,maps* m,int res){
+void
+outputResponse (service * s, maps * request_inputs, maps * request_outputs,
+                map * request_inputs1, int cpid, maps * m, int res)
+{
 #ifdef DEBUG
-  dumpMaps(request_inputs);
-  dumpMaps(request_outputs);
-  fprintf(stderr,"printProcessResponse\n");
-#endif
-  map* toto=getMap(request_inputs1,"RawDataOutput");
-  int asRaw=0;
-  if(toto!=NULL)
-    asRaw=1;
-  
-  maps* tmpSess=getMaps(m,"senv");
-  if(tmpSess!=NULL){
-    map *_tmp=getMapFromMaps(m,"lenv","cookie");
-    char* sessId=NULL;
-    if(_tmp!=NULL){
-      printf("Set-Cookie: %s; HttpOnly\r\n",_tmp->value);
-      printf("P3P: CP=\"IDC DSP COR ADM DEVi TAIi PSA PSD IVAi IVDi CONi HIS OUR IND CNT\"\r\n");
-      char session_file_path[100];
-      char *tmp1=strtok(_tmp->value,";");
-      if(tmp1!=NULL)
-	sprintf(session_file_path,"%s",strstr(tmp1,"=")+1);
+  dumpMaps (request_inputs);
+  dumpMaps (request_outputs);
+  fprintf (stderr, "printProcessResponse\n");
+#endif
+  map *toto = getMap (request_inputs1, "RawDataOutput");
+  int asRaw = 0;
+  if (toto != NULL)
+    asRaw = 1;
+
+  maps *tmpSess = getMaps (m, "senv");
+  if (tmpSess != NULL)
+    {
+      map *_tmp = getMapFromMaps (m, "lenv", "cookie");
+      char *sessId = NULL;
+      if (_tmp != NULL)
+        {
+          printf ("Set-Cookie: %s; HttpOnly\r\n", _tmp->value);
+          printf
+            ("P3P: CP=\"IDC DSP COR ADM DEVi TAIi PSA PSD IVAi IVDi CONi HIS OUR IND CNT\"\r\n");
+          char session_file_path[100];
+          char *tmp1 = strtok (_tmp->value, ";");
+          if (tmp1 != NULL)
+            sprintf (session_file_path, "%s", strstr (tmp1, "=") + 1);
+          else
+            sprintf (session_file_path, "%s", strstr (_tmp->value, "=") + 1);
+          sessId = strdup (session_file_path);
+        }
       else
-	sprintf(session_file_path,"%s",strstr(_tmp->value,"=")+1);
-      sessId=strdup(session_file_path);
-    }else{
-      maps* t=getMaps(m,"senv");
-      map*p=t->content;
-      while(p!=NULL){
-	if(strstr(p->name,"ID")!=NULL){
-	  sessId=strdup(p->value);
-	  break;
-	}
-	p=p->next;
-      }
-    }
-    char session_file_path[1024];
-    map *tmpPath=getMapFromMaps(m,"main","sessPath");
-    if(tmpPath==NULL)
-      tmpPath=getMapFromMaps(m,"main","tmpPath");
-    sprintf(session_file_path,"%s/sess_%s.cfg",tmpPath->value,sessId);
-    FILE* teste=fopen(session_file_path,"w");
-    if(teste==NULL){
-      char tmpMsg[1024];
-      sprintf(tmpMsg,_("Unable to create the file : \"%s\" for storing the session maps."),session_file_path);
-      map * errormap = createMap("text",tmpMsg);
-      addToMap(errormap,"code", "InternalError");
-      
-      printExceptionReportResponse(m,errormap);
-      freeMap(&errormap);
-      free(errormap);
-      return;
-    }
-    else{
-      fclose(teste);
-      dumpMapsToFile(tmpSess,session_file_path);
-    }
-  }
-  
-
-  if(asRaw==0){
+        {
+          maps *t = getMaps (m, "senv");
+          map *p = t->content;
+          while (p != NULL)
+            {
+              if (strstr (p->name, "ID") != NULL)
+                {
+                  sessId = strdup (p->value);
+                  break;
+                }
+              p = p->next;
+            }
+        }
+      char session_file_path[1024];
+      map *tmpPath = getMapFromMaps (m, "main", "sessPath");
+      if (tmpPath == NULL)
+        tmpPath = getMapFromMaps (m, "main", "tmpPath");
+      sprintf (session_file_path, "%s/sess_%s.cfg", tmpPath->value, sessId);
+      FILE *teste = fopen (session_file_path, "w");
+      if (teste == NULL)
+        {
+          char tmpMsg[1024];
+          sprintf (tmpMsg,
+                   _
+                   ("Unable to create the file : \"%s\" for storing the session maps."),
+                   session_file_path);
+          map *errormap = createMap ("text", tmpMsg);
+          addToMap (errormap, "code", "InternalError");
+
+          printExceptionReportResponse (m, errormap);
+          freeMap (&errormap);
+          free (errormap);
+          return;
+        }
+      else
+        {
+          fclose (teste);
+          dumpMapsToFile (tmpSess, session_file_path);
+        }
+    }
+
+
+  if (asRaw == 0)
+    {
 #ifdef DEBUG
-    fprintf(stderr,"REQUEST_OUTPUTS FINAL\n");
-    dumpMaps(request_outputs);
-#endif
-    maps* tmpI=request_outputs;
-    while(tmpI!=NULL){
+      fprintf (stderr, "REQUEST_OUTPUTS FINAL\n");
+      dumpMaps (request_outputs);
+#endif
+      maps *tmpI = request_outputs;
+      while (tmpI != NULL)
+        {
 #ifdef USE_MS
-      map* testMap=getMap(tmpI->content,"useMapserver");	
-#endif
-      toto=getMap(tmpI->content,"asReference");
+          map *testMap = getMap (tmpI->content, "useMapserver");
+#endif
+          toto = getMap (tmpI->content, "asReference");
 #ifdef USE_MS
-      if(toto!=NULL && strcasecmp(toto->value,"true")==0 && testMap==NULL)
+          if (toto != NULL && strcasecmp (toto->value, "true") == 0
+              && testMap == NULL)
 #else
-      if(toto!=NULL && strcasecmp(toto->value,"true")==0)
-#endif
-	{
-	elements* in=getElements(s->outputs,tmpI->name);
-	char *format=NULL;
-	if(in!=NULL){
-	  format=strdup(in->format);
-	}else
-	  format=strdup("LiteralData");
-	if(strcasecmp(format,"BoundingBoxData")==0){
-	  addToMap(tmpI->content,"extension","xml");
-	  addToMap(tmpI->content,"mimeType","text/xml");
-	  addToMap(tmpI->content,"encoding","UTF-8");
-	  addToMap(tmpI->content,"schema","http://schemas.opengis.net/ows/1.1.0/owsCommon.xsd");
-	}
-	map *ext=getMap(tmpI->content,"extension");
-	map *tmp1=getMapFromMaps(m,"main","tmpPath");
-	char *file_name,*file_path;
-	bool hasExt=true;
-	if(ext==NULL){
-	  // We can fallback to a default list of supported formats using
-	  // mimeType information if present here. Maybe we can add more formats
-	  // here.
-	  // If mimeType was not found, we then set txt as the default extension
-	  map* mtype=getMap(tmpI->content,"mimeType");
-	  if(mtype!=NULL){
-	    if(strcasecmp(mtype->value,"text/xml")==0)
-	      ext=createMap("extension","xml");
-	    else if(strcasecmp(mtype->value,"application/json")==0)
-	      ext=createMap("extension","js");
-	    else if(strncmp(mtype->value,"application/vnd.google-earth.kml",32)==0)
-	      ext=createMap("extension","kml");
-	    else if(strncmp(mtype->value,"image/",6)==0)
-	      ext=createMap("extension",strstr(mtype->value,"/")+1);
-	    else
-	      ext=createMap("extension","txt");
-	  }
-	  else
-	    ext=createMap("extension","txt");
-	  hasExt=false;
-	}
-	file_name=(char*)malloc((strlen(s->name)+strlen(ext->value)+strlen(tmpI->name)+1024)*sizeof(char));
-	int cpid0=cpid+time(NULL);
-	sprintf(file_name,"%s_%s_%i.%s",s->name,tmpI->name,cpid0,ext->value);
-	file_path=(char*)malloc((strlen(tmp1->value)+strlen(file_name)+2)*sizeof(char));
-	sprintf(file_path,"%s/%s",tmp1->value,file_name);
-	FILE *ofile=fopen(file_path,"wb");
-	if(ofile==NULL){
-	  char tmpMsg[1024];
-	  sprintf(tmpMsg,_("Unable to create the file : \"%s\" for storing the %s final result."),file_name,tmpI->name);
-	  map * errormap = createMap("text",tmpMsg);
-	  addToMap(errormap,"code", "InternalError");
-	  printExceptionReportResponse(m,errormap);
-	  freeMap(&errormap);
-	  free(errormap);
-	  free(file_name);
-	  free(file_path);
-	  return;
-	}
-	free(file_path);
-	map *tmp2=getMapFromMaps(m,"main","tmpUrl");
-	map *tmp3=getMapFromMaps(m,"main","serverAddress");
-	char *file_url;
-	if(strncasecmp(tmp2->value,"http://",7)==0 ||
-	   strncasecmp(tmp2->value,"https://",8)==0){
-	  file_url=(char*)malloc((strlen(tmp2->value)+strlen(file_name)+2)*sizeof(char));
-	  sprintf(file_url,"%s/%s",tmp2->value,file_name);
-	}else{
-	  file_url=(char*)malloc((strlen(tmp3->value)+strlen(tmp2->value)+strlen(file_name)+3)*sizeof(char));
-	  sprintf(file_url,"%s/%s/%s",tmp3->value,tmp2->value,file_name);
-	}
-	addToMap(tmpI->content,"Reference",file_url);
-	if(!hasExt){
-	  freeMap(&ext);
-	  free(ext);
-	}
-	toto=getMap(tmpI->content,"value");
-	if(strcasecmp(format,"BoundingBoxData")!=0){
-	  map* size=getMap(tmpI->content,"size");
-	  if(size!=NULL && toto!=NULL)
-	    fwrite(toto->value,1,atoi(size->value)*sizeof(char),ofile);
-	  else
-	    if(toto!=NULL && toto->value!=NULL)
-	      fwrite(toto->value,1,strlen(toto->value)*sizeof(char),ofile);
-	}else{
-	  printBoundingBoxDocument(m,tmpI,ofile);
-	}
-	free(format);
-	fclose(ofile);
-	free(file_name);
-	free(file_url);	
-	}
+          if (toto != NULL && strcasecmp (toto->value, "true") == 0)
+#endif
+            {
+              elements *in = getElements (s->outputs, tmpI->name);
+              char *format = NULL;
+              if (in != NULL)
+                {
+                  format = strdup (in->format);
+                }
+              else
+                format = strdup ("LiteralData");
+              if (strcasecmp (format, "BoundingBoxData") == 0)
+                {
+                  addToMap (tmpI->content, "extension", "xml");
+                  addToMap (tmpI->content, "mimeType", "text/xml");
+                  addToMap (tmpI->content, "encoding", "UTF-8");
+                  addToMap (tmpI->content, "schema",
+                            "http://schemas.opengis.net/ows/1.1.0/owsCommon.xsd");
+                }
+              map *ext = getMap (tmpI->content, "extension");
+              map *tmp1 = getMapFromMaps (m, "main", "tmpPath");
+              char *file_name, *file_path;
+              bool hasExt = true;
+              if (ext == NULL)
+                {
+                  // We can fallback to a default list of supported formats using
+                  // mimeType information if present here. Maybe we can add more formats
+                  // here.
+                  // If mimeType was not found, we then set txt as the default extension
+                  map *mtype = getMap (tmpI->content, "mimeType");
+                  if (mtype != NULL)
+                    {
+                      if (strcasecmp (mtype->value, "text/xml") == 0)
+                        ext = createMap ("extension", "xml");
+                      else if (strcasecmp (mtype->value, "application/json")
+                               == 0)
+                        ext = createMap ("extension", "js");
+                      else
+                        if (strncmp
+                            (mtype->value, "application/vnd.google-earth.kml",
+                             32) == 0)
+                        ext = createMap ("extension", "kml");
+                      else if (strncmp (mtype->value, "image/", 6) == 0)
+                        ext =
+                          createMap ("extension",
+                                     strstr (mtype->value, "/") + 1);
+                      else
+                        ext = createMap ("extension", "txt");
+                    }
+                  else
+                    ext = createMap ("extension", "txt");
+                  hasExt = false;
+                }
+              file_name =
+                (char *)
+                malloc ((strlen (s->name) + strlen (ext->value) +
+                         strlen (tmpI->name) + 1024) * sizeof (char));
+              int cpid0 = cpid + time (NULL);
+              sprintf (file_name, "%s_%s_%i.%s", s->name, tmpI->name, cpid0,
+                       ext->value);
+              file_path =
+                (char *)
+                malloc ((strlen (tmp1->value) + strlen (file_name) +
+                         2) * sizeof (char));
+              sprintf (file_path, "%s/%s", tmp1->value, file_name);
+              FILE *ofile = fopen (file_path, "wb");
+              if (ofile == NULL)
+                {
+                  char tmpMsg[1024];
+                  sprintf (tmpMsg,
+                           _
+                           ("Unable to create the file : \"%s\" for storing the %s final result."),
+                           file_name, tmpI->name);
+                  map *errormap = createMap ("text", tmpMsg);
+                  addToMap (errormap, "code", "InternalError");
+                  printExceptionReportResponse (m, errormap);
+                  freeMap (&errormap);
+                  free (errormap);
+                  free (file_name);
+                  free (file_path);
+                  return;
+                }
+              free (file_path);
+              map *tmp2 = getMapFromMaps (m, "main", "tmpUrl");
+              map *tmp3 = getMapFromMaps (m, "main", "serverAddress");
+              char *file_url;
+              if (strncasecmp (tmp2->value, "http://", 7) == 0 ||
+                  strncasecmp (tmp2->value, "https://", 8) == 0)
+                {
+                  file_url =
+                    (char *)
+                    malloc ((strlen (tmp2->value) + strlen (file_name) +
+                             2) * sizeof (char));
+                  sprintf (file_url, "%s/%s", tmp2->value, file_name);
+                }
+              else
+                {
+                  file_url =
+                    (char *)
+                    malloc ((strlen (tmp3->value) + strlen (tmp2->value) +
+                             strlen (file_name) + 3) * sizeof (char));
+                  sprintf (file_url, "%s/%s/%s", tmp3->value, tmp2->value,
+                           file_name);
+                }
+              addToMap (tmpI->content, "Reference", file_url);
+              if (!hasExt)
+                {
+                  freeMap (&ext);
+                  free (ext);
+                }
+              toto = getMap (tmpI->content, "value");
+              if (strcasecmp (format, "BoundingBoxData") != 0)
+                {
+                  map *size = getMap (tmpI->content, "size");
+                  if (size != NULL && toto != NULL)
+                    fwrite (toto->value, 1,
+                            atoi (size->value) * sizeof (char), ofile);
+                  else if (toto != NULL && toto->value != NULL)
+                    fwrite (toto->value, 1,
+                            strlen (toto->value) * sizeof (char), ofile);
+                }
+              else
+                {
+                  printBoundingBoxDocument (m, tmpI, ofile);
+                }
+              free (format);
+              fclose (ofile);
+              free (file_name);
+              free (file_url);
+            }
 #ifdef USE_MS
-      else{
-	if(testMap!=NULL){
-	  setReferenceUrl(m,tmpI);
-	}
-      }
-#endif
-      tmpI=tmpI->next;
-    }
-    map *r_inputs=getMap(s->content,"serviceProvider");
+          else
+            {
+              if (testMap != NULL)
+                {
+                  setReferenceUrl (m, tmpI);
+                }
+            }
+#endif
+          tmpI = tmpI->next;
+        }
+      map *r_inputs = getMap (s->content, "serviceProvider");
 #ifdef DEBUG
-    fprintf(stderr,"SERVICE : %s\n",r_inputs->value);
-    dumpMaps(m);
-#endif
-    printProcessResponse(m,request_inputs1,cpid,
-			 s,r_inputs->value,res,
-			 request_inputs,
-			 request_outputs);
-    }
-    else{
-      if(res==SERVICE_FAILED){
-	map * errormap;
-	map *lenv;
-	lenv=getMapFromMaps(m,"lenv","message");
-	char *tmp0;
-	if(lenv!=NULL){
-	  tmp0=(char*)malloc((strlen(lenv->value)+strlen(_("Unable to run the Service. The message returned back by the Service was the following: "))+1)*sizeof(char));
-	  sprintf(tmp0,_("Unable to run the Service. The message returned back by the Service was the following: %s"),lenv->value);
-	}
-	else{
-	  tmp0=(char*)malloc((strlen(_("Unable to run the Service. No more information was returned back by the Service."))+1)*sizeof(char));
-	  sprintf(tmp0,_("Unable to run the Service. No more information was returned back by the Service."));
-	}
-	errormap = createMap("text",tmp0);
-	free(tmp0);
-	addToMap(errormap,"code", "InternalError");
-	printExceptionReportResponse(m,errormap);
-	freeMap(&errormap);
-	free(errormap);
-	return;
-      }
+      fprintf (stderr, "SERVICE : %s\n", r_inputs->value);
+      dumpMaps (m);
+#endif
+      printProcessResponse (m, request_inputs1, cpid,
+                            s, r_inputs->value, res,
+                            request_inputs, request_outputs);
+    }
+  else
+    {
+      if (res == SERVICE_FAILED)
+        {
+          map *errormap;
+          map *lenv;
+          lenv = getMapFromMaps (m, "lenv", "message");
+          char *tmp0;
+          if (lenv != NULL)
+            {
+              tmp0 =
+                (char *)
+                malloc ((strlen (lenv->value) +
+                         strlen (_
+                                 ("Unable to run the Service. The message returned back by the Service was the following: "))
+                         + 1) * sizeof (char));
+              sprintf (tmp0,
+                       _
+                       ("Unable to run the Service. The message returned back by the Service was the following: %s"),
+                       lenv->value);
+            }
+          else
+            {
+              tmp0 =
+                (char *)
+                malloc ((strlen
+                         (_
+                          ("Unable to run the Service. No more information was returned back by the Service."))
+                         + 1) * sizeof (char));
+              sprintf (tmp0,
+                       _
+                       ("Unable to run the Service. No more information was returned back by the Service."));
+            }
+          errormap = createMap ("text", tmp0);
+          free (tmp0);
+          addToMap (errormap, "code", "InternalError");
+          printExceptionReportResponse (m, errormap);
+          freeMap (&errormap);
+          free (errormap);
+          return;
+        }
       /**
        * We get the requested output or fallback to the first one if the 
        * requested one is not present in the resulting outputs maps.
        */
-      maps* tmpI=NULL;
-      map* tmpIV=getMap(request_inputs1,"RawDataOutput");
-      if(tmpIV!=NULL){
-	tmpI=getMaps(request_outputs,tmpIV->value);
-      }
-      if(tmpI==NULL)
-	tmpI=request_outputs;
-      elements* e=getElements(s->outputs,tmpI->name);
-      if(e!=NULL && strcasecmp(e->format,"BoundingBoxData")==0){
-	printBoundingBoxDocument(m,tmpI,NULL);
-      }else{
-	toto=getMap(tmpI->content,"value");
-	if(toto==NULL){
-	  char tmpMsg[1024];
-	  sprintf(tmpMsg,_("Wrong RawDataOutput parameter, unable to fetch any result for the name your provided : \"%s\"."),tmpI->name);
-	  map * errormap = createMap("text",tmpMsg);
-	  addToMap(errormap,"code", "InvalidParameterValue");
-	  printExceptionReportResponse(m,errormap);
-	  freeMap(&errormap);
-	  free(errormap);
-	  return;
-	}
-	map* fname=getMapFromMaps(tmpI,tmpI->name,"filename");
-	if(fname!=NULL)
-	  printf("Content-Disposition: attachment; filename=\"%s\"\r\n",fname->value);
-	map* rs=getMapFromMaps(tmpI,tmpI->name,"size");
-	if(rs!=NULL)
-	  printf("Content-Length: %s\r\n",rs->value);
-	printHeaders(m);
-	char mime[1024];
-	map* mi=getMap(tmpI->content,"mimeType");
+      maps *tmpI = NULL;
+      map *tmpIV = getMap (request_inputs1, "RawDataOutput");
+      if (tmpIV != NULL)
+        {
+          tmpI = getMaps (request_outputs, tmpIV->value);
+        }
+      if (tmpI == NULL)
+        tmpI = request_outputs;
+      elements *e = getElements (s->outputs, tmpI->name);
+      if (e != NULL && strcasecmp (e->format, "BoundingBoxData") == 0)
+        {
+          printBoundingBoxDocument (m, tmpI, NULL);
+        }
+      else
+        {
+          toto = getMap (tmpI->content, "value");
+          if (toto == NULL)
+            {
+              char tmpMsg[1024];
+              sprintf (tmpMsg,
+                       _
+                       ("Wrong RawDataOutput parameter, unable to fetch any result for the name your provided : \"%s\"."),
+                       tmpI->name);
+              map *errormap = createMap ("text", tmpMsg);
+              addToMap (errormap, "code", "InvalidParameterValue");
+              printExceptionReportResponse (m, errormap);
+              freeMap (&errormap);
+              free (errormap);
+              return;
+            }
+          map *fname = getMapFromMaps (tmpI, tmpI->name, "filename");
+          if (fname != NULL)
+            printf ("Content-Disposition: attachment; filename=\"%s\"\r\n",
+                    fname->value);
+          map *rs = getMapFromMaps (tmpI, tmpI->name, "size");
+          if (rs != NULL)
+            printf ("Content-Length: %s\r\n", rs->value);
+          printHeaders (m);
+          char mime[1024];
+          map *mi = getMap (tmpI->content, "mimeType");
 #ifdef DEBUG
-	fprintf(stderr,"SERVICE OUTPUTS\n");
-	dumpMaps(request_outputs);
-	fprintf(stderr,"SERVICE OUTPUTS\n");
-#endif
-	map* en=getMap(tmpI->content,"encoding");
-	if(mi!=NULL && en!=NULL)
-	  sprintf(mime,
-		  "Content-Type: %s; charset=%s\r\nStatus: 200 OK\r\n\r\n",
-		  mi->value,en->value);
-	else
-	  if(mi!=NULL)
-	    sprintf(mime,
-		    "Content-Type: %s; charset=UTF-8\r\nStatus: 200 OK\r\n\r\n",
-		    mi->value);
-	  else
-	    sprintf(mime,"Content-Type: text/plain; charset=utf-8\r\nStatus: 200 OK\r\n\r\n");
-	printf("%s",mime);
-	if(rs!=NULL)
-	  fwrite(toto->value,1,atoi(rs->value),stdout);
-	else
-	  fwrite(toto->value,1,strlen(toto->value),stdout);
+          fprintf (stderr, "SERVICE OUTPUTS\n");
+          dumpMaps (request_outputs);
+          fprintf (stderr, "SERVICE OUTPUTS\n");
+#endif
+          map *en = getMap (tmpI->content, "encoding");
+          if (mi != NULL && en != NULL)
+            sprintf (mime,
+                     "Content-Type: %s; charset=%s\r\nStatus: 200 OK\r\n\r\n",
+                     mi->value, en->value);
+          else if (mi != NULL)
+            sprintf (mime,
+                     "Content-Type: %s; charset=UTF-8\r\nStatus: 200 OK\r\n\r\n",
+                     mi->value);
+          else
+            sprintf (mime,
+                     "Content-Type: text/plain; charset=utf-8\r\nStatus: 200 OK\r\n\r\n");
+          printf ("%s", mime);
+          if (rs != NULL)
+            fwrite (toto->value, 1, atoi (rs->value), stdout);
+          else
+            fwrite (toto->value, 1, strlen (toto->value), stdout);
 #ifdef DEBUG
-	dumpMap(toto);
-#endif
-      }
-    }
-}
-
-char *base64(const char *input, int length)
+          dumpMap (toto);
+#endif
+        }
+    }
+}
+
+char *
+base64 (const char *input, int length)
 {
   BIO *bmem, *b64;
   BUF_MEM *bptr;
 
-  b64 = BIO_new(BIO_f_base64());
-  BIO_set_flags(b64, BIO_FLAGS_BASE64_NO_NL);
-  bmem = BIO_new(BIO_s_mem());
-  b64 = BIO_push(b64, bmem);
-  BIO_write(b64, input, length+1);
-  BIO_flush(b64);
-  BIO_get_mem_ptr(b64, &bptr);
-
-  char *buff = (char *)malloc((bptr->length+1)*sizeof(char));
-  memcpy(buff, bptr->data, bptr->length);
-  buff[bptr->length-1] = 0;
-
-  BIO_free_all(b64);
+  b64 = BIO_new (BIO_f_base64 ());
+  BIO_set_flags (b64, BIO_FLAGS_BASE64_NO_NL);
+  bmem = BIO_new (BIO_s_mem ());
+  b64 = BIO_push (b64, bmem);
+  BIO_write (b64, input, length + 1);
+  BIO_flush (b64);
+  BIO_get_mem_ptr (b64, &bptr);
+
+  char *buff = (char *) malloc ((bptr->length + 1) * sizeof (char));
+  memcpy (buff, bptr->data, bptr->length);
+  buff[bptr->length - 1] = 0;
+
+  BIO_free_all (b64);
 
   return buff;
 }
 
-char *base64d(const char *input, int length,int* red)
+char *
+base64d (const char *input, int length, int *red)
 {
   BIO *b64, *bmem;
 
-  char *buffer = (char *)malloc(length);
-  if(buffer){
-    memset(buffer, 0, length);
-    b64 = BIO_new(BIO_f_base64());
-    if(b64){
-      bmem = BIO_new_mem_buf((unsigned char*)input,length);
-      bmem = BIO_push(b64, bmem);
-      *red=BIO_read(bmem, buffer, length);
-      buffer[length-1]=0;
-      BIO_free_all(bmem);
-    }
-  }
+  char *buffer = (char *) malloc (length);
+  if (buffer)
+    {
+      memset (buffer, 0, length);
+      b64 = BIO_new (BIO_f_base64 ());
+      if (b64)
+        {
+          bmem = BIO_new_mem_buf ((unsigned char *) input, length);
+          bmem = BIO_push (b64, bmem);
+          *red = BIO_read (bmem, buffer, length);
+          buffer[length - 1] = 0;
+          BIO_free_all (bmem);
+        }
+    }
   return buffer;
 }
 
-void ensureDecodedBase64(maps **in){
-  maps* cursor=*in;
-  while(cursor!=NULL){
-    map *tmp=getMap(cursor->content,"encoding");
-    if(tmp!=NULL && strncasecmp(tmp->value,"base64",6)==0){
-      tmp=getMap(cursor->content,"value");
-      addToMap(cursor->content,"base64_value",tmp->value);
-      int size=0;
-      char *s=strdup(tmp->value);
-      free(tmp->value);
-      tmp->value=base64d(s,strlen(s),&size);
-      free(s);
-      char sizes[1024];
-      sprintf(sizes,"%d",size);
-      addToMap(cursor->content,"size",sizes);
-    }
-    cursor=cursor->next;
-  }
-}
-
-char* addDefaultValues(maps** out,elements* in,maps* m,int type){
-  elements* tmpInputs=in;
-  maps* out1=*out;
-  if(type==1){
-    while(out1!=NULL){
-      if(getElements(in,out1->name)==NULL)
-	return out1->name;
-      out1=out1->next;
-    }
-    out1=*out;
-  }
-  while(tmpInputs!=NULL){
-    maps *tmpMaps=getMaps(out1,tmpInputs->name);
-    if(tmpMaps==NULL){
-      maps* tmpMaps2=(maps*)malloc(MAPS_SIZE);
-      tmpMaps2->name=strdup(tmpInputs->name);
-      tmpMaps2->content=NULL;
-      tmpMaps2->next=NULL;
-      
-      if(type==0){
-	map* tmpMapMinO=getMap(tmpInputs->content,"minOccurs");
-	if(tmpMapMinO!=NULL){
-	  if(atoi(tmpMapMinO->value)>=1){
-	    freeMaps(&tmpMaps2);
-	    free(tmpMaps2);
-	    return tmpInputs->name;
-	  }
-	  else{
-	    if(tmpMaps2->content==NULL)
-	      tmpMaps2->content=createMap("minOccurs",tmpMapMinO->value);
-	    else
-	      addToMap(tmpMaps2->content,"minOccurs",tmpMapMinO->value);
-	  }
-	}
-	map* tmpMaxO=getMap(tmpInputs->content,"maxOccurs");
-	if(tmpMaxO!=NULL){
-	  if(tmpMaps2->content==NULL)
-	    tmpMaps2->content=createMap("maxOccurs",tmpMaxO->value);
-	  else
-	    addToMap(tmpMaps2->content,"maxOccurs",tmpMaxO->value);
-	}
-	map* tmpMaxMB=getMap(tmpInputs->content,"maximumMegabytes");
-	if(tmpMaxMB!=NULL){
-	  if(tmpMaps2->content==NULL)
-	    tmpMaps2->content=createMap("maximumMegabytes",tmpMaxMB->value);
-	  else
-	    addToMap(tmpMaps2->content,"maximumMegabytes",tmpMaxMB->value);
-	}
-      }
-
-      iotype* tmpIoType=tmpInputs->defaults;
-      if(tmpIoType!=NULL){
-	map* tmpm=tmpIoType->content;
-	while(tmpm!=NULL){
-	  if(tmpMaps2->content==NULL)
-	    tmpMaps2->content=createMap(tmpm->name,tmpm->value);
-	  else
-	    addToMap(tmpMaps2->content,tmpm->name,tmpm->value);
-	  tmpm=tmpm->next;
-	}
-      }
-      addToMap(tmpMaps2->content,"inRequest","false");
-      if(type==0){
-	map *tmpMap=getMap(tmpMaps2->content,"value");
-	if(tmpMap==NULL)
-	  addToMap(tmpMaps2->content,"value","NULL");
-      }
-      if(out1==NULL){
-	*out=dupMaps(&tmpMaps2);
-	out1=*out;
-      }
+void
+ensureDecodedBase64 (maps ** in)
+{
+  maps *cursor = *in;
+  while (cursor != NULL)
+    {
+      map *tmp = getMap (cursor->content, "encoding");
+      if (tmp != NULL && strncasecmp (tmp->value, "base64", 6) == 0)
+        {
+          tmp = getMap (cursor->content, "value");
+          addToMap (cursor->content, "base64_value", tmp->value);
+          int size = 0;
+          char *s = strdup (tmp->value);
+          free (tmp->value);
+          tmp->value = base64d (s, strlen (s), &size);
+          free (s);
+          char sizes[1024];
+          sprintf (sizes, "%d", size);
+          addToMap (cursor->content, "size", sizes);
+        }
+      cursor = cursor->next;
+    }
+}
+
+char *
+addDefaultValues (maps ** out, elements * in, maps * m, int type)
+{
+  elements *tmpInputs = in;
+  maps *out1 = *out;
+  if (type == 1)
+    {
+      while (out1 != NULL)
+        {
+          if (getElements (in, out1->name) == NULL)
+            return out1->name;
+          out1 = out1->next;
+        }
+      out1 = *out;
+    }
+  while (tmpInputs != NULL)
+    {
+      maps *tmpMaps = getMaps (out1, tmpInputs->name);
+      if (tmpMaps == NULL)
+        {
+          maps *tmpMaps2 = (maps *) malloc (MAPS_SIZE);
+          tmpMaps2->name = strdup (tmpInputs->name);
+          tmpMaps2->content = NULL;
+          tmpMaps2->next = NULL;
+
+          if (type == 0)
+            {
+              map *tmpMapMinO = getMap (tmpInputs->content, "minOccurs");
+              if (tmpMapMinO != NULL)
+                {
+                  if (atoi (tmpMapMinO->value) >= 1)
+                    {
+                      freeMaps (&tmpMaps2);
+                      free (tmpMaps2);
+                      return tmpInputs->name;
+                    }
+                  else
+                    {
+                      if (tmpMaps2->content == NULL)
+                        tmpMaps2->content =
+                          createMap ("minOccurs", tmpMapMinO->value);
+                      else
+                        addToMap (tmpMaps2->content, "minOccurs",
+                                  tmpMapMinO->value);
+                    }
+                }
+              map *tmpMaxO = getMap (tmpInputs->content, "maxOccurs");
+              if (tmpMaxO != NULL)
+                {
+                  if (tmpMaps2->content == NULL)
+                    tmpMaps2->content =
+                      createMap ("maxOccurs", tmpMaxO->value);
+                  else
+                    addToMap (tmpMaps2->content, "maxOccurs", tmpMaxO->value);
+                }
+              map *tmpMaxMB = getMap (tmpInputs->content, "maximumMegabytes");
+              if (tmpMaxMB != NULL)
+                {
+                  if (tmpMaps2->content == NULL)
+                    tmpMaps2->content =
+                      createMap ("maximumMegabytes", tmpMaxMB->value);
+                  else
+                    addToMap (tmpMaps2->content, "maximumMegabytes",
+                              tmpMaxMB->value);
+                }
+            }
+
+          iotype *tmpIoType = tmpInputs->defaults;
+          if (tmpIoType != NULL)
+            {
+              map *tmpm = tmpIoType->content;
+              while (tmpm != NULL)
+                {
+                  if (tmpMaps2->content == NULL)
+                    tmpMaps2->content = createMap (tmpm->name, tmpm->value);
+                  else
+                    addToMap (tmpMaps2->content, tmpm->name, tmpm->value);
+                  tmpm = tmpm->next;
+                }
+            }
+          addToMap (tmpMaps2->content, "inRequest", "false");
+          if (type == 0)
+            {
+              map *tmpMap = getMap (tmpMaps2->content, "value");
+              if (tmpMap == NULL)
+                addToMap (tmpMaps2->content, "value", "NULL");
+            }
+          if (out1 == NULL)
+            {
+              *out = dupMaps (&tmpMaps2);
+              out1 = *out;
+            }
+          else
+            addMapsToMaps (&out1, tmpMaps2);
+          freeMap (&tmpMaps2->content);
+          free (tmpMaps2->content);
+          tmpMaps2->content = NULL;
+          freeMaps (&tmpMaps2);
+          free (tmpMaps2);
+          tmpMaps2 = NULL;
+        }
       else
-	addMapsToMaps(&out1,tmpMaps2);
-      freeMap(&tmpMaps2->content);
-      free(tmpMaps2->content);
-      tmpMaps2->content=NULL;
-      freeMaps(&tmpMaps2);
-      free(tmpMaps2);
-      tmpMaps2=NULL;
-    }
-    else{
-      iotype* tmpIoType=getIoTypeFromElement(tmpInputs,tmpInputs->name,
-					     tmpMaps->content);
-      if(type==0) {
-	/**
+        {
+          iotype *tmpIoType =
+            getIoTypeFromElement (tmpInputs, tmpInputs->name,
+                                  tmpMaps->content);
+          if (type == 0)
+            {
+        /**
 	 * In case of an Input maps, then add the minOccurs and maxOccurs to the
 	 * content map.
 	 */
-	map* tmpMap1=getMap(tmpInputs->content,"minOccurs");
-	if(tmpMap1!=NULL){
-	  if(tmpMaps->content==NULL)
-	    tmpMaps->content=createMap("minOccurs",tmpMap1->value);
-	  else
-	    addToMap(tmpMaps->content,"minOccurs",tmpMap1->value);
-	}
-	map* tmpMaxO=getMap(tmpInputs->content,"maxOccurs");
-	if(tmpMaxO!=NULL){
-	  if(tmpMaps->content==NULL)
-	    tmpMaps->content=createMap("maxOccurs",tmpMaxO->value);
-	  else
-	    addToMap(tmpMaps->content,"maxOccurs",tmpMaxO->value);
-	}
-	map* tmpMaxMB=getMap(tmpInputs->content,"maximumMegabytes");
-	if(tmpMaxMB!=NULL){
-	  if(tmpMaps->content==NULL)
-	    tmpMaps->content=createMap("maximumMegabytes",tmpMaxMB->value);
-	  else
-	    addToMap(tmpMaps->content,"maximumMegabytes",tmpMaxMB->value);
-	}
-	/**
+              map *tmpMap1 = getMap (tmpInputs->content, "minOccurs");
+              if (tmpMap1 != NULL)
+                {
+                  if (tmpMaps->content == NULL)
+                    tmpMaps->content =
+                      createMap ("minOccurs", tmpMap1->value);
+                  else
+                    addToMap (tmpMaps->content, "minOccurs", tmpMap1->value);
+                }
+              map *tmpMaxO = getMap (tmpInputs->content, "maxOccurs");
+              if (tmpMaxO != NULL)
+                {
+                  if (tmpMaps->content == NULL)
+                    tmpMaps->content =
+                      createMap ("maxOccurs", tmpMaxO->value);
+                  else
+                    addToMap (tmpMaps->content, "maxOccurs", tmpMaxO->value);
+                }
+              map *tmpMaxMB = getMap (tmpInputs->content, "maximumMegabytes");
+              if (tmpMaxMB != NULL)
+                {
+                  if (tmpMaps->content == NULL)
+                    tmpMaps->content =
+                      createMap ("maximumMegabytes", tmpMaxMB->value);
+                  else
+                    addToMap (tmpMaps->content, "maximumMegabytes",
+                              tmpMaxMB->value);
+                }
+        /**
 	 * Parsing BoundingBoxData, fill the following map and then add it to
 	 * the content map of the Input maps: 
